searchNodes=[{"doc":"An Ecto type for ULID strings.","ref":"Ecto.ULID.html","title":"Ecto.ULID","type":"module"},{"doc":"Generates a binary ULID. Optionally takes a Unix timestamp wtih millisecond precision as an argument. If no argument is passed, the current time is used as a base for the ULID. Examples iex&gt; Ecto.ULID . bingenerate ( ) &lt;&lt; 1 , 127 , 29 , 107 , 117 , 125 , 183 , 154 , 147 , 224 , 191 , 135 , 161 , 183 , 2 , 52 &gt;&gt; iex&gt; Ecto.ULID . bingenerate ( 1402899630000 ) &lt;&lt; 1 , 70 , 163 , 85 , 135 , 176 , 12 , 219 , 112 , 32 , 157 , 209 , 98 , 152 , 55 , 37 &gt;&gt;","ref":"Ecto.ULID.html#bingenerate/1","title":"Ecto.ULID.bingenerate/1","type":"function"},{"doc":"Casts a string to ULID. Example iex&gt; Ecto.ULID . cast ( &quot;018THNB1XG1KDQ084XT5H9GDS5&quot; ) { :ok , &quot;018THNB1XG1KDQ084XT5H9GDS5&quot; } iex&gt; Ecto.ULID . cast ( &quot;abc&quot; ) :error","ref":"Ecto.ULID.html#cast/1","title":"Ecto.ULID.cast/1","type":"function"},{"doc":"Same as cast/1 , but raises Ecto.CastError on invalid arguments. Example iex&gt; Ecto.ULID . cast! ( &quot;018THNB1XG1KDQ084XT5H9GDS5&quot; ) &quot;018THNB1XG1KDQ084XT5H9GDS5&quot; iex&gt; Ecto.ULID . cast! ( &quot;abc&quot; ) ** (Ecto.CastError) cannot cast &quot;abc&quot; to Ecto.ULID","ref":"Ecto.ULID.html#cast!/1","title":"Ecto.ULID.cast!/1","type":"function"},{"doc":"Converts a Crockford Base32 encoded ULID into a binary. Example iex&gt; Ecto.ULID . dump ( &quot;018THNB1XG1KDQ084XT5H9GDS5&quot; ) { :ok , &lt;&lt; 1 , 70 , 163 , 85 , 135 , 176 , 12 , 219 , 112 , 32 , 157 , 209 , 98 , 152 , 55 , 37 &gt;&gt; }","ref":"Ecto.ULID.html#dump/1","title":"Ecto.ULID.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Ecto.ULID.html#embed_as/1","title":"Ecto.ULID.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Ecto.ULID.html#equal?/2","title":"Ecto.ULID.equal?/2","type":"function"},{"doc":"Generates a Crockford Base32 encoded ULID. Optionally takes a Unix timestamp wtih millisecond precision as an argument. If no argument is passed, the current time is used as a base for the ULID. Examples iex&gt; Ecto.ULID . generate ( ) &quot;01FWEPCVGGMQQ0YTKS7BYFQH46&quot; iex&gt; Ecto.ULID . generate ( 1402899630000 ) &quot;018THNB1XGQZ7T929PD126SM3Z&quot;","ref":"Ecto.ULID.html#generate/1","title":"Ecto.ULID.generate/1","type":"function"},{"doc":"Converts a binary ULID into a Crockford Base32 encoded string. Example iex&gt; Ecto.ULID . load ( &lt;&lt; 1 , 70 , 163 , 85 , 135 , 176 , 12 , 219 , 112 , 32 , 157 , 209 , 98 , 152 , 55 , 37 &gt;&gt; ) { :ok , &quot;018THNB1XG1KDQ084XT5H9GDS5&quot; }","ref":"Ecto.ULID.html#load/1","title":"Ecto.ULID.load/1","type":"function"},{"doc":"The underlying schema type ( :uuid ).","ref":"Ecto.ULID.html#type/0","title":"Ecto.ULID.type/0","type":"function"},{"doc":"A hex-encoded ULID string.","ref":"Ecto.ULID.html#t:t/0","title":"Ecto.ULID.t/0","type":"type"},{"doc":"An Ecto.Type implementation of ULID . Ecto.ULID should be compatible anywhere that Ecto.UUID is supported. It has been confirmed to work with PostgreSQL and MySQL on Ecto ~&gt; 3.2. ULID is a 128-bit universally unique lexicographically sortable identifier. ULID is binary-compatible with UUID, so it can be stored in a uuid column in a database. This is a fork of TheRealReal/ecto-ulid , which doesn't seem to be maintained anymore. The aim is to ensure compatibility with current and future Ecto versions.","ref":"readme.html","title":"Ecto.ULID Next","type":"extras"},{"doc":"Generate ULID in Base32 or binary format. Generate ULID for a given timestamp. Autogenerate ULID when used as a primary key. Supports reading and writing ULID in a database backed by its native uuid type (no database extensions required). Supports Ecto ~&gt; 3.2. Supports the officially supported Elixir versions (currently ~&gt; 1.10). Confirmed working on PostgreSQL and MySQL. Optimized for high throughput.","ref":"readme.html#features","title":"Ecto.ULID Next - Features","type":"extras"},{"doc":"Since one use case of ULID is to handle a large volume of events, Ecto.ULID is optimized to be as fast as possible. It borrows techniques from Ecto.UUID to achieve sub-microsecond times for most operations. A benchmark suite is included. Download the repository and run mix run bench/ulid_bench.exs to test the performance on your system.","ref":"readme.html#performance","title":"Ecto.ULID Next - Performance","type":"extras"},{"doc":"Usage is very similar to Ecto.UUID . The following example shows how to use Ecto.ULID as a primary key in a database table, but it can be used for other columns just as easily. API documentation is available on hexdocs. Install Install ecto_ulid_next from Hex by adding it to the dependencies in mix.exs : defp deps do [ { :ecto_ulid_next , &quot;~&gt; 1.0.0&quot; } ] end Migration Since ULID is binary-compatible with UUID, the migrations look the same for both types. Use :binary_id when defining a column in a migration: create table ( :events , primary_key : false ) do add :id , :binary_id , null : false , primary_key : true # more columns ... end Alternatively, if you plan to use ULID as the primary key type for all of your tables, you can set migration_primary_key when configuring your Repo : config :my_app , MyApp.Repo , migration_primary_key : [ name : :id , type : :binary_id ] In this case, you do not need to specify the id column in your migrations: create table ( :events ) do # more columns ... end Schema When defining a model's schema, use Ecto.ULID as the @primary_key or @foreign_key_type as appropriate for your schema. Here's an example of using both: defmodule MyApp.Event do use Ecto.Schema @primary_key { :id , Ecto.ULID , autogenerate : false } @foreign_key_type Ecto.ULID schema &quot;events&quot; do # more columns ... end end Ecto.ULID supports autogenerate: true as well as autogenerate: false when used as the primary key. Application Usage A ULID can be generated in string or binary format by calling generate/0 or bingenerate/0 . This can be useful when generating ULIDs to send to external systems: iex&gt; Ecto.ULID . generate ( ) &quot;01BZ13RV29T5S8HV45EDNC748P&quot; iex&gt; Ecto.ULID . bingenerate ( ) &lt;&lt; 1 , 95 , 194 , 60 , 108 , 73 , 209 , 114 , 136 , 236 , 133 , 115 , 106 , 195 , 145 , 22 &gt;&gt; To backfill old data, it may be helpful to pass a timestamp to generate/1 or bingenerate/1 . See the API documentation for more details.","ref":"readme.html#usage","title":"Ecto.ULID Next - Usage","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Stable release. Changed Minor dependency and documentation updates.","ref":"changelog.html#1-0-0-2022-12-14","title":"Changelog - [1.0.0] - 2022-12-14","type":"extras"},{"doc":"Maintenance release Changed Elixir version support now follows the officially supported Elixir versions . Update test matrix accordingly. Improve documentation and type specs.","ref":"changelog.html#0-3-1-2022-02-22","title":"Changelog - [0.3.1] - 2022-02-22","type":"extras"},{"doc":"Changed Minimum supported Ecto is now 3.2. Minimum supported Elixir is now 1.7.","ref":"changelog.html#0-3-0-2020-11-16","title":"Changelog - [0.3.0] - 2020-11-16","type":"extras"},{"doc":"Changed Minimum supported Elixir is now 1.4. ( #3 ) Fix deprecation warnings regarding time units.","ref":"changelog.html#0-2-0-2019-01-17","title":"Changelog - [0.2.0] - 2019-01-17","type":"extras"},{"doc":"Added ( #2 ) Add support for Ecto 3.x.","ref":"changelog.html#0-1-1-2018-12-03","title":"Changelog - [0.1.1] - 2018-12-03","type":"extras"},{"doc":"Added Generate ULID in Base32 or binary format. Generate ULID for a given timestamp. Autogenerate ULID when used as a primary key. Supports reading and writing ULID in a database backed by its native uuid type (no database extensions required). Supports Ecto 2.x. Supports Elixir 1.2 and newer. Tested with PostgreSQL and MySQL.","ref":"changelog.html#0-1-0-2018-06-06","title":"Changelog - [0.1.0] - 2018-06-06","type":"extras"}]